/*----------------------------------------------------------------------------*/
// File: contact.c   USGS Navigation, handle the contact closure board
// Blame: John Gann
// Start Date: 1 June 1992
/*----------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <time.h>
#include <fcntl.h>
#include <io.h>

#include <GRconst.h>
#include <GRports.h>
#include <GRextrn.h>
#include <menuet.h>

#include "navdefs.h"
#include "navtypes.h"
#include "nav_util.h"
#include "mnutils.h"
#include "serial.h"
#include "contact.h"



/*----------------------------------------------------------------------------*/
// Set the contact closure status
/*----------------------------------------------------------------------------*/
int doRelayFm(ob_desc * ob)
{
int retv;
fm_desc * fm;
char * frf = "relay.frf";
ftag * tag;
t_setup * config = QuerySetup();
int i;

/* Load the FRF file */
if ( ( fm = loadFRF ( frf ) ) == NULL ) 
	{
  return FALSE;
	}

for (i=0; i<MAX_RELAYS; i++)
	{
	if (config->relay.relaysEnabled[i])
		{
		fm->ob_lst[OFFSET_1 + i].flags |= IS_CHECKED;
		}
	else
		{
		fm->ob_lst[OFFSET_1 + i].flags &= ~IS_CHECKED;
		}

	// update the intervals
	tag = (ftag *) fm->ob_lst[OFFSET_2 + i].tag;
	sprintf(tag->fld, "%d", config->relay.relayIntervals[i]);
	}

OpenForm ( fm, 10, 40); 

do 
	{
	retv = ProcessObList ( fm->ob_lst, fm->ob_cnt, 0 );
	switch ( retv ) 
		{
		case OKAY:
			for (i=0; i<MAX_RELAYS; i++)
				{
				// get the enabled buttons
				config->relay.relaysEnabled[i] = 
              (fm->ob_lst[OFFSET_1 + i].flags & IS_CHECKED) ? TRUE : FALSE;
			
				// update the intervals
				tag = (ftag *) fm->ob_lst[OFFSET_2 + i].tag;
				config->relay.relayIntervals[i] = atoi(tag->fld);
				}
			break;

		case 1:                                  // CANCEL:
			break;

		default : 
			break;
		}
	} while (retv != OKAY && retv != CANCEL && retv != 1);

CloseForm   ( fm );
DestroyFRFForm ( fm );

return retv;
}

