typedef struct  
	{
	char name[20];									/* name of ellipsoid */
	double a;												/* semi-major axis */
	double b;												/* semi-minor axis */
	double f;												/* flattenning f=(a-b)/a  */
	double e2;											/* first eccentricity^2 */
	} t_ellips;

typedef struct  
	{
	char id;                        // index to datum enumerated list
	char conversion;								// molodensky or multiple regression
	char name[30];									// name of datum 
	t_ellips ellipsoid;							// ellipsoid structure
	char coef_file[14];							// file containing datum shift cooeficients
	} t_datum;

t_ellips * query_ellipsoid(int ellips_idx);


#define AIRY                      0
#define AUSTRALIAN                1
#define BESSEL                    2
#define CLARKE_1866               3
#define EVEREST                   4
#define GRS_80                    5
#define INTERNATIONAL             6
#define SO_AMERICAN_69            7
#define WGS_84                    8
#define WGS_72                    9
#define CLARKE_1880               10

#define NO_CONVERSION             0
#define MRE                       2
#define MOLODENSKY                3
