/*----------------------------------------------------------------------------*/
// File: shape.c USGS Navigation, handle coastline files
// Blame: John Gann
// Start Date: 11 June 1992
/*----------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <time.h>
#include <fcntl.h>
#include <io.h>

#include <GRconst.h>
#include <GRports.h>
#include <GRextrn.h>
#include <menuet.h>

#include "navdefs.h"
#include "navtypes.h"
#include "nav_utils.h"
#include "coast.h"
#include "shapes.h"

// private

// externals
extern char RefreshRequired;
extern t_shape Vessel;


/*---------------------------------------------------------------------------*/
// Select the Shape from a list
/*---------------------------------------------------------------------------*/
int doShapeListFm(ob_desc * ob)
{
char filename[_MAX_PATH];
t_setup * config = QuerySetup();
int retv;
char path[_MAX_PATH];

strcpy(path, CurrentDir());
strcat(path, "\\*.shp");

retv = pickFilename("Select Shape File", path, filename);
if (retv == SUCCESS)
	{
	// copy the new shape
	strcpy(config->ShipName, FileNameP(filename));
	read_shape(&Vessel, filename);

	// cause the screen to refresh
	RefreshRequired = TRUE;
	}

return retv;
}



/*----------------------------------------------------------------------------*/
// read in any shape file
/*----------------------------------------------------------------------------*/
int read_shape(t_shape * shape, char * filename)
{
FILE *fp;
int k;

if ((fp = fopen(filename, "rb")) == NULL)
  {
  printf("\nCan't open file %s", filename);
  return FALSE;
  }

k = fread( (void *) shape, sizeof(t_shape), 1, fp);
if (k == -1)
	{
	fclose(fp);
	printf("\nfread failed");
	return FALSE;
	}

fclose(fp);
return TRUE;
}



