#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <time.h>
#include <direct.h>
#include <sys\types.h>
#include <sys\stat.h>

#include <GRconst.h>
#include <GRports.h>
#include <GRextrn.h>
#include <MENUET.h>

#include <bmem.h>

#include "navdefs.h"
#include "navtypes.h"
#include "filehndl.h"
#include "dispasci.h"
#include "mnutils.h"
#include "sysinfo.h"


static unsigned memblk, nextblk;
static MEMCTRL ctlblock;

extern char DisplayingSomething;

/*----------------------------------------------------------------------------*/
// dump some system info with the hot key
/*----------------------------------------------------------------------------*/
void process_inspection_port_key(void)
{
int      status = SUCCESS;
int      i;      
fm_desc  *sysInfoFm;
char *   frf = "sysinfo.frf";

// load the form 
sysInfoFm = loadFRF(frf);
if (sysInfoFm == NULL)
	return;

DisplayingSomething = TRUE;

sysInfoFm->ob_lst[0].task = report_system_status;
sysInfoFm->ob_lst[1].task = view_ascii_file;
sysInfoFm->ob_lst[2].task = report_available_memory;
 
OpenForm(sysInfoFm, 32, 32);
i = ProcessObList(sysInfoFm->ob_lst, sysInfoFm->ob_cnt, 0);
CloseForm(sysInfoFm);
DestroyForm(sysInfoFm);
DisplayingSomething = FALSE;
}



/*----------------------------------------------------------------------------*/
// dump memory and disk usgae
/*----------------------------------------------------------------------------*/
int report_system_status(ob_desc *callingOb)
{
int      ems_free;
int      ems_total;
int      ems_handle;
int      ems_error;
struct   diskfree_t dfinfo;
unsigned long free_space, bytes_cluster;
unsigned drive_nbr;
char     buff[512];
char     s1[100];
                  
ems_free = EMS_pgfree();
ems_handle = EMS_handcnt();
ems_error = EMS_error();
ems_total = EMS_pgtotal();

sprintf( buff, 
             "EMS total=%d\nEMS free=%d\nEMS error=%d\nEMS handle count=%d\n",
             ems_total, ems_free, ems_error,
             ems_handle);
   
_dos_getdrive( &drive_nbr );
if ((_dos_getdiskfree( drive_nbr, &dfinfo )) == 0) 
	{
	bytes_cluster =dfinfo.sectors_per_cluster * dfinfo.bytes_per_sector;
	free_space = dfinfo.avail_clusters * bytes_cluster;
	sprintf( s1, "Current drive free=%ld\n",free_space );
	strcat(buff, s1);
	}
      
NotifyUser(1, 32, "SYSTEM STATUS",  buff );
return SUCCESS;
}





/*----------------------------------------------------------------------------*/
// Call view an ascii file
/*----------------------------------------------------------------------------*/
int view_ascii_file(ob_desc *callingOb)
{
char filename[_MAX_PATH];
int retv;

strcpy(filename, CurrentDir());
strcat(filename, "\\*.txt");

if ( get_input_file(filename, "Enter File Name", filename) )
	{
	retv = DisplayAsciiFile( filename, 1, 32, 10, 50);
	}
return retv; 
}




/*----------------------------------------------------------------------------*/
// Conventional memory Walk
/*----------------------------------------------------------------------------*/
int report_available_memory(ob_desc *callingOb)
{
char buf[1024];

mem_dump(buf);
NotifyUser(1, 32, "Memory Report", buf);
return SUCCESS;
}


/*----------------------------------------------------------------------------*/
// write the memory walk to a buffer
/*----------------------------------------------------------------------------*/
void mem_dump(char buf[])
{
int j = 0;

for (memblk = mmfirst(); memblk != 0; memblk = nextblk)
	{
	if (9 != mmctrl(memblk, &ctlblock, &nextblk))
		{
		if (ctlblock.owner_psp == 0)
			{
			j += sprintf(buf+j,"Block at %04xh: owner: %04xh  size: %lu bytes",
                memblk, 
                ctlblock.owner_psp,
                16L * (unsigned long) ctlblock.size);
			j += sprintf(buf+j," (free)");

			if (ctlblock.ident == 'Z')
				{
				j += sprintf(buf+j," (last_block)");
				}
		
			j += sprintf(buf+j,".\n");
			}
		}
	}
}


/*----------------------------------------------------------------------------*/
// Return the bytes of available memory by using undocumented DOS function
/*----------------------------------------------------------------------------*/
long memory_available(void)
{
long available_memory = 0L;

for (memblk = mmfirst(); memblk != 0; memblk = nextblk)
	{
	if (9 != mmctrl(memblk, &ctlblock, &nextblk))
		{
		if (ctlblock.owner_psp == 0)
			{
			available_memory += ctlblock.size;
			}
		}
	}
return 16L * available_memory;
}


/*----------------------------------------------------------------------------*/
// View Ascii file through menu
/*----------------------------------------------------------------------------*/
int doViewAsciiFile(ob_desc * ob)
{
return view_ascii_file(ob);
}
